# -*- coding: utf-8 -*-
# This file has been generated, if you wish to
# modify it in a permanent way, please refer
# to the script file : gen/generator_python.rb

from api import *
from math import *

global Portail_Potentiel
Portail_Potentiel = set()
global Mes_Portails
Mes_Portails = set()
global Ses_Portails
Ses_Portails = set()
global CacheLiens
CacheLiens = set()
global neutraliser
Neutraliser = False


# UTILITY

def Lien_Possible(pos1, pos2):
    for lien in liste_liens():
        if intersection_segments(pos1, pos2, lien[0], lien[1]) == True:
            return False
    return True

def Score_Portail(portail, potentiel = False):
    score = 0
    liste = []
    if potentiel == False:
        Liste_liens = liste_liens()        
        for lien in Liste_liens:
            if lien[0] == portail: 
                liste += [lien[1]]
            elif lien[1] == portail:
                liste += [lien[0]]
    else:
        liste = Trouver_Liens(portail)

    for i, obj in enumerate(liste):
        for j in range(i+1, len(liste)):
            obj_ = liste[j]
            if lien_existe(obj, obj_) == True:
                score += score_triangle(portail, obj, obj_)
    
    return score
        

def Analyse():
    port_adv = hist_portails_captures() + hist_portails_neutralises()

    for port in port_adv:
        Ses_Portails.add(port)
        Portail_Potentiel.discard(port)
    rm = []
    for port in Portail_Potentiel:
        if case_champs(port) != []:
            rm += [port]
    for port in rm:
        Portail_Potentiel.remove(port)
    '''
    for port in Mes_Portails:
        if len(Trouver_Liens()) > 0:
            Portail_Potentiel.add(port)
    '''

def Trouver_Capture(pos, liste):
    best = float('inf')
    liste_sort = sorted(liste,  key=lambda objectif: distance(pos, objectif) * 20 + Score_Portail(objectif, potentiel = True))
    
    return liste_sort[0]

def Trouver_Liens(pos):
    liste = []
    for port in Mes_Portails:
        if port != pos and not port in CacheLiens:
            
            if Lien_Possible(pos, port) == True:
                liste += [port]

    return liste

def Trouver_Cible(pos):
    ses_portails = []

    for port in Ses_Portails:
        ses_portails += [port]

    ses_portails = sorted(ses_portails, key=lambda port: (Score_Portail(port) * 100 + Score_Portail(port, potentiel = True) * 20 + distance(pos, port) * -15 + portail_boucliers(port) * 20),reverse = True)    
    if len(ses_portails) != 0:
        return ses_portails[0]
    else:
        return None


def Deplacer_Objectif(objectif):
    
    dist = distance(position_agent(moi()), objectif)

    while points_action() >= COUT_TURBO and dist > points_deplacement():
        utiliser_turbo()     

    if dist <= points_deplacement():
        deplacer(objectif)
        return True 
      
    else:        
        deltaX = objectif[0] - position_agent(moi())[0]
        deltaY = objectif[1] - position_agent(moi())[1]

        dif_X = 0
        dif_Y = 0

        if deltaX == 0:
            dif_Y = points_deplacement() * (deltaY / abs(deltaY))

        elif deltaY == 0:
            dif_X = points_deplacement() * (deltaX/ abs(deltaX))

        else:

            if abs(deltaX) <= points_deplacement():
                dif_X = deltaX
                dif_Y = (points_deplacement() - abs(deltaX)) * (deltaY / abs(deltaY))
            else:
                dif_X = points_deplacement() * (deltaX / abs(deltaX))
        
        pos = (position_agent(moi())[0] + dif_X, position_agent(moi())[1] + dif_Y)
        deplacer(pos)
        return False
            
        
# Fonction appelée au début de la partie.
def partie_init():
    pass 
    

# Fonction appelée à chaque tour.
def jouer_tour():

    Analyse()
    Passer = False
    global Neutraliser

    while points_action() >= COUT_TURBO and Passer == False:

        if len(CacheLiens) == 0 and len(Portail_Potentiel) != 0 and Neutraliser != True:   
            
            mission = Trouver_Capture(position_agent(moi()), Portail_Potentiel)
            
            if distance(mission, position_agent(moi())) > 10:
                mission = Trouver_Cible(position_agent(moi()))
                       
            if Deplacer_Objectif(mission) == True:
                if portail_boucliers(mission) * COUT_NEUTRALISATION_BOUCLIER + COUT_NEUTRALISATION <= points_action():
                    neutraliser()
                    Portail_Potentiel.add(mission)
                    Ses_Portails.discard(mission)
                    Neutraliser = False
                else:                
                    Passer = True
                    Neutraliser = True

            if Deplacer_Objectif(mission) == True and points_action() >= COUT_CAPTURE:
                capturer()

                for i in range(4):
                    if points_action() >= COUT_BOUCLIER:
                        ajouter_bouclier()

                Portail_Potentiel.remove(mission)
                Mes_Portails.add(mission)

                if len(Mes_Portails) >= 2:    
                    for port in Trouver_Liens(mission):              
                        CacheLiens.add(port)
                                                    
        
        elif len(CacheLiens) != 0 and Neutraliser != True:            
            while points_action() >= COUT_LIEN and len(CacheLiens) != 0:
                lier(CacheLiens.pop())
        
        else:
            mission = Trouver_Cible(position_agent(moi()))
                       
            if Deplacer_Objectif(mission) == True:
                if portail_boucliers(mission) * COUT_NEUTRALISATION_BOUCLIER + COUT_NEUTRALISATION <= points_action():
                    neutraliser()
                    Portail_Potentiel.add(mission)
                    Ses_Portails.remove(mission)
                    Neutraliser = False
            
                else:                
                    Passer = True
                    Neutraliser = True
            
  
# Fonction appelée à la fin de la partie.
def partie_fin():
    print('gg')
    pass # Place ton code ici

