# -*- coding: utf-8 -*-
# This file has been generated, if you wish to
# modify it in a permanent way, please refer
# to the script file : gen/generator_python.rb

from api import *
from math import *

global Portail_Potentiel
Portail_Potentiel = set()
global Mes_Portails
Mes_Portails = set()
global Ses_Portails
Ses_Portails = set()
global CacheLiens
CacheLiens = set()
global Cible
Cible = None


# UTILITY

def Lien_Possible(pos1, pos2):
    for lien in liste_liens():
        if intersection_segments(pos1, pos2, lien[0], lien[1]) == True:
            if case_dans_champ(pos1) == True or case_dans_champ(pos2) == True:
                return False
    return True

def Score_Portail(portail, potentiel = False):
    score = 0
    liste = []
    if potentiel == False:
        Liste_liens = liste_liens()        
        for lien in Liste_liens:
            if lien[0] == portail: 
                liste += [lien[1]]
            elif lien[1] == portail:
                liste += [lien[0]]
    else:
        liste = Trouver_Liens(portail)

    for i, obj in enumerate(liste):
        for j in range(i+1, len(liste)):
            obj_ = liste[j]
            if lien_existe(obj, obj_) == True:
                score += score_triangle(portail, obj, obj_)
    
    return score
        

def Trouver_Capture(pos):
    best = float('inf')
    liste_sort = sorted(Portail_Potentiel,  key=lambda objectif: distance(pos, objectif) * -20 + Score_Portail(objectif, potentiel = True * 1) + (pow(TAILLE_TERRAIN / 2 - objectif[0], 2) + pow(TAILLE_TERRAIN / 2 - objectif[1], 2)) , reverse = True)
    
    return liste_sort[0]

def Trouver_Liens(pos):
    liste = []
    for port in Mes_Portails:
        if port != pos:
            if Lien_Possible(pos, port) == True:
                if len(CacheLiens) != 0:
                    for cache in CacheLiens:
                        if cache[0] != pos or cache[1] != port:  
                            if cache[1] != pos or cache[0] != port:              
                                    liste += [port]
                else:
                    liste += [port]
                            
    return liste

def Trouver_Cible(pos):
    ses_portails = []

    for port in Ses_Portails:
        ses_portails += [port]

    ses_portails = sorted(ses_portails, key=lambda port: (Score_Portail(port) * 100 + Score_Portail(port, potentiel = True) * 20 + distance(pos, port) * -30 + portail_boucliers(port) * 20),reverse = True)    
    
    return ses_portails[0]   


def Deplacer_Objectif(objectif):
    
    dist = distance(position_agent(moi()), objectif)

    while points_action() >= COUT_TURBO and dist > points_deplacement():
        utiliser_turbo()     

    if dist <= points_deplacement():
        deplacer(objectif)
        return True 
      
    else:        
        deltaX = objectif[0] - position_agent(moi())[0]
        deltaY = objectif[1] - position_agent(moi())[1]

        dif_X = 0
        dif_Y = 0

        if deltaX == 0:
            dif_Y = points_deplacement() * (deltaY / abs(deltaY))

        elif deltaY == 0:
            dif_X = points_deplacement() * (deltaX/ abs(deltaX))

        else:

            if abs(deltaX) <= points_deplacement():
                dif_X = deltaX
                dif_Y = (points_deplacement() - abs(deltaX)) * (deltaY / abs(deltaY))
            else:
                dif_X = points_deplacement() * (deltaX / abs(deltaX))
        
        pos = (position_agent(moi())[0] + dif_X, position_agent(moi())[1] + dif_Y)
        deplacer(pos)
        return False

def Capturer():
    capturer()
    pos = position_agent(moi())
    for i in range(6):
        if points_action() >= COUT_BOUCLIER:
            ajouter_bouclier()

    Portail_Potentiel.remove(pos)
    Mes_Portails.add(pos)

    
    for port in Trouver_Liens(pos):              
        CacheLiens.add((pos, port))
        
def Analyse():
    port_adv = hist_portails_captures() + hist_portails_neutralises()

    for port in port_adv:
        Ses_Portails.add(port)
        Portail_Potentiel.discard(port)
    rm = []
    
    for port in rm:
        Portail_Potentiel.remove(port)
    
    for port in liste_portails():
        if case_dans_champ(port) == True:
            Portail_Potentiel.discard(port)
    rm = []
    for port in Portail_Potentiel:
        if distance(position_agent(moi()), port) > 25:
            rm += [port]
    for port in rm:
        Portail_Potentiel.remove(port)

    CacheLiens.clear()
    for port in Mes_Portails:
        if distance(port, position_agent(moi())) < 7:
            for port in Trouver_Liens(port):              
                CacheLiens.add((position_agent(moi()), port))           
        
# Fonction appelée au début de la partie.
def partie_init():
    for port in liste_portails():
        Portail_Potentiel.add(port)

# Fonction appelée à chaque tour.
def jouer_tour():

    Analyse()
    Passer = False
    global Cible
    Passif = False

    while points_action() >= COUT_TURBO and Passer == False:
        
        if len(CacheLiens) != 0 and Cible == None:     

            liste = []
            for lien in CacheLiens:
                liste += [lien[0], lien[1]]

            liste = sorted(liste, key = lambda port: distance(position_agent(moi()), port))            

            if distance(position_agent(moi()), liste[0]) < 7:
                if Deplacer_Objectif(liste[0]) == True and points_action() >= COUT_LIEN:
                    next = False
                    while points_action() >= COUT_LIEN and next == False:                                              
                        for lien in CacheLiens:                             
                            if lien[0] == position_agent(moi()):
                                lier(lien[1])
                                CacheLiens.remove(lien)
                                break
                            elif lien[1] == position_agent(moi()):
                                lier(lien[0])
                                CacheLiens.remove(lien)
                                break
                        else:
                            Passif = False
                            next = True
        
        if len(Portail_Potentiel) != 0 and Cible == None:               
            mission = Trouver_Capture(position_agent(moi()))
            if Deplacer_Objectif(mission) == True and points_action() >= COUT_CAPTURE:
                Capturer() 
                Passif = True

                for port in Trouver_Liens(mission):

                    CacheLiens.add((mission, port))                          
                                                       
        
        if len(Ses_Portails) != 0 and Passif == False:
            if Cible == None:
                mission = Trouver_Cible(position_agent(moi()))
            else:
                mission = Cible
            
            if Deplacer_Objectif(mission) == True:
                if portail_boucliers(mission) * COUT_NEUTRALISATION_BOUCLIER + COUT_NEUTRALISATION <= points_action():
                    neutraliser()                    
                    Ses_Portails.remove(mission)
                    Cible = None

                    if points_action() >= COUT_CAPTURE:
                        Capturer()    
                        Passif = True                    
                    else:
                        Portail_Potentiel.add(mission)
                        Passer = True
            
                else:                
                    Passer = True
                    Cible = mission

  
# Fonction appelée à la fin de la partie.
def partie_fin():
    print('gg')
    pass # Place ton code ici

